--[[=============================================================================
    Copyright 2015 Control4 Corporation. All Rights Reserved.
===============================================================================]]

-- This macro is utilized to identify the version string of the driver template version used.
if (TEMPLATE_VERSION ~= nil) then
	TEMPLATE_VERSION.device_specific_commands = "2015.03.31"
end

--[[=============================================================================
    ExecuteCommand Code

    Define any functions for device specific commands (EX_CMD.<command>)
    received from ExecuteCommand that need to be handled by the driver.
===============================================================================]]
--function EX_CMD.NEW_COMMAND(tParams)
--	LogTrace("EX_CMD.NEW_COMMAND")
--	LogTrace(tParams)
--end

--[[
	Device Command: ZonePower
	Parameters:
		Power: Power state: values are "ON" and "OFF"
		Zone: zone id (1 based, must be corrected for zero based connection ids)
--]]
function LUA_ACTION.ROUTE(tParams)
    SetRoute(tParams["Input"],tParams["Output"])
end
function LUA_ACTION.PON()
    PON()
end
function LUA_ACTION.POF()
    POF()
end
function LUA_ACTION.SEND(tParams)
    
    PackAndQueueCommand("SEND", tParams["Command"])
end

function RoutePacket(input, output)
    return "#video_d out".. string.format( "%d", output).." matrix="..string.format( "%d",input )
end

function SetRoute(input, output)
local command = RoutePacket(input ,output)
    PackAndQueueCommand("SET_INPUT", command)
    --proxyFeedbackRoutingState(1000 + input,2000 + output)
end

function PON()
        PackAndQueueCommand("ON", "#power start=1")
        --proxyFeedbackPower(true)
end

function POF()
    PackAndQueueCommand("OFF", "#power shut=1")
    --proxyFeedbackPower(false)
end
